//Main_Program.ino

#define Ready 8
#define Relay 10
#define Warning 9
char tag[] ="4A00C7865B95"; // Replace with your Tag ID
char input[12];				
int count = 0;				
boolean match = 0;			// A variable to store the Tag match status
void setup()
{
	Serial.begin(9600);
        pinMode(Ready,OUTPUT);		
	pinMode(Relay,OUTPUT);	
	pinMode(Warning,OUTPUT); 
}
void loop()
{        
        digitalWrite(Ready,HIGH);
  
	if(Serial.available())// check serial data ( RFID reader)
	{        
                digitalWrite(Ready,LOW);
		count = 0; // Reset the counter to zero
		/* Keep reading Byte by Byte from the Buffer till the RFID Reader Buffer is	empty 
		   or till 12 Bytes (the ID size of our Tag) is read */
		while(Serial.available() && count < 12) 
		{
			input[count] = Serial.read(); // Read 1 Byte of data and store it in the input[] variable
			count++; // increment counter
			delay(5);
		}
		/* When the counter reaches 12 (the size of the ID) we stop and compare each value 
		    of the input[] to the corresponding stored value */
		if(count == 12) // 
		{
			count =0; // reset counter varibale to 0
			match = 1;
			/* Iterate through each value and compare till either the 12 values are 
			   all matching or till the first mistmatch occurs */
			while(count<12 && match !=0)  
			{
				if(input[count]==tag[count])
				match = 1; // everytime the values match, we set the match variable to 1
				else
				match= 0; 
                               /* if the ID values don't match, set match variable to 0 and 
                                  stop comparing by exiting the while loop */
				count++; // increment i
			}
		}
		if(match == 1) // If match variable is 1, then it means the tags match
		{
			Serial.println("Congratulation Access Allowed");
			digitalWrite(Relay,HIGH);
			delay (5000);				// Relay on for 5 sec
			digitalWrite (Relay,LOW);
		}
		else
		{
			Serial.println("Access Denied"); // Incorrect Tag Message
			digitalWrite(Warning,HIGH);
			delay(500);
			digitalWrite(Warning,LOW);
		}
		/* Fill the input variable array with a fixed value 'F' to overwrite 
		all values getting it	empty for the next read cycle */
		for(count=0; count<12; count++) 
		{
			input[count]= 'F';
		}
		count = 0; // Reset counter variable
	}
}
